* Program examples for c2xx                          *
* PM - Program memory    DM - Data memory            *
* Command file         : c203.cmd                    *
* Assembler batch file : a.bat                       *
* Linker batch file    : l.bat                       *
*						     *
* Function: Pulsing of XF                            *
*						     *
* Input to counter is CLKOUT1                        *
*	    CLKXOX - 0 selects CLKOUT1 as            *
*           the input to the counter                 *
*						     *
*	    CLKXOX - 1 selects CLKX as               *
*           the input to the counter                 *
* Check : Timer using FSXCT/CLXCT                    *                                                    
* Rev 2.0                                            *
* Written by: Sam Saba/ASP/St,TX       Date: 7/17/97 *

        .title  " ESSP Burst mode"    ; Title 
	.copy "init.h"    	; Variable and register declaration
        .copy "vector.h"        ; Vector label declaration     
	.text

start:
	CLRC CNF                ; Block B0 in DM, as CNFD
	LDP #0h                 ; set DP=0
	SETC INTM               ; Disable all interrupts
	splk #0000h,60h		; I/O wait states =zero
        out 60h, wsgr
        splk #0cf0ah,60h        ; reset the serial port by writing
	out 60h, sspcr		; zeros  
        splk #0cf3ah,60h	; Burst mode
        out 60h,sspcr		; enable Sync port, 4 word fifo,
                                ; CLX/FSR as outputs. 
*ESSP register initialization
        splk #00ffh,60h           
        out  60h,SSPCT          
        splk #0005h,60h         ; GPC and GPI enabled        
        out  60h,SSPMC          ; b 0000 0000 0000 0101 =0005h
				; Xmit interrupt for timer enabled
				; GPI =1, GPC =1
        splk #0100h,60h         ; counter i/p is CLKOUT1       
        out  60h,SSPST          ; 	

main:   splk #10h,imr           ; enable xmit interrupt
	clrc intm		
			
	splk #55aah,62h		; dummy data for tx
	
        mar *,ar1		; load ar1 with rx buffer
	lar ar1, #rxbuf
	lar ar0, #size
	
loop:	nop			; wait for transmit buffer empty
        idle
        in 70h,SSPST
        out 62h,sdtr		; transmit  again
        in 71h,SSPST
   
	b loop

codtx:
       in *+,SSPCT
       mar *,ar0
       banz skip,ar1		; buffer limit check
       lar ar1,#rxbuf
       lar ar0,#size			
       in 65h,sspcr 

skip   setc xf
       nop 
       nop
       nop	
       clrc xf
       splk #10h,ifr
       clrc intm
       ret
	
codrx:  
       splk #0008h, ifr         ; clear ifr bit due to this interrupt  
       clrc intm
       ret			
inpt1: 	ret
inpt23:	ret
time:  	ret
uart:  	ret	
	.end                    ; Assembler module end directive -optional

* Note: if the program is working correctly, XF should pulse 

* Timer output frequency = CLKOUT1 / (2 * SSPCT)
* where SSPCT is the value in SSPCT register in decimal